% CIS601 - Tom Gradel - Homework 7

% Clean up any old figures
close all;

% Number of images
IFIGURE = 12;
im = cell(IFIGURE,2); % Cell array for images

% Number of PCA components
IPCACOMP = 12;

% Images are roughly the same sime, but trim images to this size
IROW = 135;
ICOL = 135;

% File names for textures
im{1,1} = 'grass.bmp';
im{2,1} = 'dirt.bmp';
im{3,1} = 'knit.bmp';
im{4,1} = 'hair.bmp';
im{5,1} = 'stones.bmp';
im{6,1} = 'plaid.bmp';
im{7,1} = 'grass2.bmp';
im{8,1} = 'dirt2.bmp';
im{9,1} = 'knit2.bmp';
im{10,1} = 'hair2.bmp';
im{11,1} = 'stones2.bmp';
im{12,1} = 'plaid2.bmp';

% load the images
for x=1:IFIGURE
    I = rgb2gray(imread(im{x,1}));
    im{x,2} = I([1:IROW],[1:ICOL]);
end 

% Stack these vectors
S = cat(3, im{1,2}, im{2,2}, im{3,2}, im{4,2}, im{5,2}, im{6,2}, ...
    im{7,2}, im{8,2}, im{9,2}, im{10,2}, im{11,2}, im{12,2});

% Organize stack into array X

[X,R] = imstack2vectors(S);

% Obtain the principal-components
P = princomp(X, IPCACOMP);

% Show the images
figure;
for x=1:IFIGURE
    subplot(4,3,x); imshow(im{x,1});  title(['FIGURE: ', num2str(x)]);
end

% Extract and show the component
figure;
for x=1:IFIGURE
    g = P.Y(:,x);
    g = reshape(g, IROW, ICOL);
    subplot(4,3,x); imshow(g,[]); title(['COMPONENT: ', num2str(x)]);
end
%


